diff -pruN 0.0.23.1-4/debian/changelog 0.0.23.1-5/debian/changelog
--- 0.0.23.1-4/debian/changelog	2019-08-05 16:56:58.000000000 +0000
+++ 0.0.23.1-5/debian/changelog	2020-08-18 09:48:00.000000000 +0000
@@ -1,3 +1,15 @@
+0ad (0.0.23.1-5) unstable; urgency=medium
+
+  * Fix FTBFS with gcc-10. (Closes: #956967)
+  * Avoid build-dep on unversioned python2. (Closes: #967118)
+  * Cherrypick patch from upstream to add workaround for L3 cache detection on
+    Ryzen 3000 series CPUs. (Closes: #949699)
+  * Update to dh compat level 12.
+  * Update Standards version to 4.5.0.
+  * Add upstream metadata file.
+
+ -- Vincent Cheng <vcheng@debian.org>  Tue, 18 Aug 2020 02:48:00 -0700
+
 0ad (0.0.23.1-4) unstable; urgency=medium
 
   * Team upload.
diff -pruN 0.0.23.1-4/debian/compat 0.0.23.1-5/debian/compat
--- 0.0.23.1-4/debian/compat	2019-08-05 16:56:58.000000000 +0000
+++ 0.0.23.1-5/debian/compat	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-10
diff -pruN 0.0.23.1-4/debian/control 0.0.23.1-5/debian/control
--- 0.0.23.1-4/debian/control	2019-08-05 16:56:58.000000000 +0000
+++ 0.0.23.1-5/debian/control	2020-08-18 09:48:00.000000000 +0000
@@ -7,7 +7,7 @@ Uploaders:
  Ludovic Rousseau <rousseau@debian.org>
 Build-Depends:
  autoconf,
- debhelper (>= 10),
+ debhelper-compat (= 12),
  dpkg-dev (>= 1.15.5),
  libboost-dev,
  libboost-filesystem-dev,
@@ -28,13 +28,14 @@ Build-Depends:
  libxcursor-dev,
  libxml2-dev,
  pkg-config,
- python,
+ python2,
  python3,
  zlib1g-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.5.0
 Homepage: http://play0ad.com/
 Vcs-Git: https://salsa.debian.org/games-team/0ad.git
 Vcs-Browser: https://salsa.debian.org/games-team/0ad
+Rules-Requires-Root: no
 
 Package: 0ad
 Architecture: amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386
@@ -54,4 +55,3 @@ Description: Real-time strategy game of
  and 500 A.D. The project is highly ambitious, involving state-of-the-art 3D
  graphics, detailed artwork, sound, and a flexible and powerful custom-built
  game engine.
-
diff -pruN 0.0.23.1-4/debian/NEWS 0.0.23.1-5/debian/NEWS
--- 0.0.23.1-4/debian/NEWS	2019-08-05 16:56:58.000000000 +0000
+++ 0.0.23.1-5/debian/NEWS	1970-01-01 00:00:00.000000000 +0000
@@ -1,22 +0,0 @@
-0ad (0.0.23.1-3) unstable; urgency=medium
-
-  0 A.D. is now built against the GTK 3 variant of the wxWidgets library that
-  has a known issue in Wayland desktop environments: Atlas editor crashes at
-  startup.
-
-  Users of Wayland environments need to work around that issues by forcing the
-  use of X11/Xwayland. Launch Atlas editor from a terminal by this command:
-
-  GDK_BACKEND=x11 pyrogenesis -editor
-
-  For details see: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=900678#10
-
-  If you don't know if you are affacted, please execute the following command in
-  a terminal:
-  
-  echo $WAYLAND_DISPLAY
-
-  If it prints something similar to 'wayland-0', please use the workaround as
-  described above!
-
- -- Bruno Kleinert <fuddl@debian.org>  Sat, 03 Aug 2019 05:56:46 +0200
diff -pruN 0.0.23.1-4/debian/patches/allow-build-with-root.patch 0.0.23.1-5/debian/patches/allow-build-with-root.patch
--- 0.0.23.1-4/debian/patches/allow-build-with-root.patch	2019-08-05 16:56:58.000000000 +0000
+++ 0.0.23.1-5/debian/patches/allow-build-with-root.patch	2020-08-18 09:48:00.000000000 +0000
@@ -1,5 +1,5 @@
 Description: Allow building 0ad as root/fakeroot
-Forwarded: no
+Forwarded: not-needed
 Author: Rico Tzschichholz <ricotz@ubuntu.com>
 Last-Update: 2014-10-13
 
diff -pruN 0.0.23.1-4/debian/patches/fix-ftbfs-gcc-10.patch 0.0.23.1-5/debian/patches/fix-ftbfs-gcc-10.patch
--- 0.0.23.1-4/debian/patches/fix-ftbfs-gcc-10.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.0.23.1-5/debian/patches/fix-ftbfs-gcc-10.patch	2020-08-18 09:48:00.000000000 +0000
@@ -0,0 +1,106 @@
+Description: Fix FTBFS with gcc-10
+Origin: upstream, https://trac.wildfiregames.com/changeset/23794
+Bug: https://trac.wildfiregames.com/ticket/5756
+Bug-Debian: https://bugs.debian.org/956967
+
+--- a/libraries/source/fcollada/src/FColladaPlugins/FArchiveXML/FAXPhysicsExport.cpp
++++ b/libraries/source/fcollada/src/FColladaPlugins/FArchiveXML/FAXPhysicsExport.cpp
+@@ -329,16 +329,3 @@
+ 		FArchiveXML::LetWriteObject(physicsRigidBodyParameters->GetPhysicsShape(i), techniqueNode);
+ 	}
+ }
+-
+-template <class TYPE, int QUAL>
+-xmlNode* FArchiveXML::AddPhysicsParameter(xmlNode* parentNode, const char* name, FCDParameterAnimatableT<TYPE,QUAL>& value)
+-{
+-	xmlNode* paramNode = AddChild(parentNode, name);
+-	AddContent(paramNode, FUStringConversion::ToString((TYPE&) value));
+-	if (value.IsAnimated())
+-	{
+-		const FCDAnimated* animated = value.GetAnimated();
+-		FArchiveXML::WriteAnimatedValue(animated, paramNode, name);
+-	}
+-	return paramNode;
+-}
+--- a/libraries/source/fcollada/src/FColladaPlugins/FArchiveXML/FArchiveXML.h
++++ b/libraries/source/fcollada/src/FColladaPlugins/FArchiveXML/FArchiveXML.h
+@@ -553,7 +553,16 @@
+ 
+ 	static void WritePhysicsRigidBodyParameters(FCDPhysicsRigidBodyParameters* physicsRigidBodyParameters, xmlNode* techniqueNode);
+ 	template <class TYPE, int QUAL>
+-	static xmlNode* AddPhysicsParameter(xmlNode* parentNode, const char* name, FCDParameterAnimatableT<TYPE,QUAL>& value);
++	static xmlNode* AddPhysicsParameter(xmlNode* parentNode, const char* name, FCDParameterAnimatableT<TYPE,QUAL>& value) {
++		xmlNode* paramNode = AddChild(parentNode, name);
++		AddContent(paramNode, FUStringConversion::ToString((TYPE&) value));
++		if (value.IsAnimated())
++		{
++			const FCDAnimated* animated = value.GetAnimated();
++			FArchiveXML::WriteAnimatedValue(animated, paramNode, name);
++		}
++		return paramNode;
++	}
+ 
+ 
+ 	//
+--- a/source/simulation2/helpers/HierarchicalPathfinder.cpp
++++ b/source/simulation2/helpers/HierarchicalPathfinder.cpp
+@@ -697,28 +697,6 @@
+ 	jGoal = jBest;
+ }
+ 
+-void HierarchicalPathfinder::FindReachableRegions(RegionID from, std::set<RegionID>& reachable, pass_class_t passClass)
+-{
+-	// Flood-fill the region graph, starting at 'from',
+-	// collecting all the regions that are reachable via edges
+-
+-	std::vector<RegionID> open;
+-	open.push_back(from);
+-	reachable.insert(from);
+-
+-	while (!open.empty())
+-	{
+-		RegionID curr = open.back();
+-		open.pop_back();
+-
+-		for (const RegionID& region : m_Edges[passClass][curr])
+-			// Add to the reachable set; if this is the first time we added
+-			// it then also add it to the open list
+-			if (reachable.insert(region).second)
+-				open.push_back(region);
+-	}
+-}
+-
+ void HierarchicalPathfinder::FindPassableRegions(std::set<RegionID>& regions, pass_class_t passClass)
+ {
+ 	// Construct a set of all regions of all chunks for this pass class
+--- a/source/simulation2/helpers/HierarchicalPathfinder.h
++++ b/source/simulation2/helpers/HierarchicalPathfinder.h
+@@ -148,7 +148,27 @@
+ 
+ 	void FindEdges(u8 ci, u8 cj, pass_class_t passClass, EdgesMap& edges);
+ 
+-	void FindReachableRegions(RegionID from, std::set<RegionID>& reachable, pass_class_t passClass);
++	void FindReachableRegions(RegionID from, std::set<RegionID>& reachable, pass_class_t passClass)
++	{
++		// Flood-fill the region graph, starting at 'from',
++		// collecting all the regions that are reachable via edges
++
++		std::vector<RegionID> open;
++		open.push_back(from);
++		reachable.insert(from);
++
++		while (!open.empty())
++		{
++			RegionID curr = open.back();
++			open.pop_back();
++
++			for (const RegionID& region : m_Edges[passClass][curr])
++				// Add to the reachable set; if this is the first time we added
++				// it then also add it to the open list
++				if (reachable.insert(region).second)
++					open.push_back(region);
++		}
++	}
+ 
+ 	void FindPassableRegions(std::set<RegionID>& regions, pass_class_t passClass);
+ 
diff -pruN 0.0.23.1-4/debian/patches/fix-ryzen-l3-cache-error.patch 0.0.23.1-5/debian/patches/fix-ryzen-l3-cache-error.patch
--- 0.0.23.1-4/debian/patches/fix-ryzen-l3-cache-error.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.0.23.1-5/debian/patches/fix-ryzen-l3-cache-error.patch	2020-08-18 09:48:00.000000000 +0000
@@ -0,0 +1,19 @@
+From: Nicolas Auvray <na.itms76@gmail.com>
+Date: Thu, 13 Aug 2020 18:27:44 +0200
+Subject: Fix #949699 on 0.0.23b
+Description: Workaround for L3 cache detection of Ryzen 3000
+Bug: https://trac.wildfiregames.com/ticket/4360
+Bug-Debian: https://bugs.debian.org/949699
+
+--- a/source/lib/sysdep/arch/x86_x64/cache.cpp
++++ b/source/lib/sysdep/arch/x86_x64/cache.cpp
+@@ -89,7 +89,8 @@
+ static const size_t associativityTable[16] =
+ {
+ 	0, 1, 2, 0, 4, 0, 8, 0,
+-	16, 0, 32, 48, 64, 96, 128, x86_x64::Cache::fullyAssociative
++	// TODO: The second '16' does not obey to the specifications and is only a workaround. For a correct implementation please look here: https://community.amd.com/thread/244207
++	16, 16, 32, 48, 64, 96, 128, x86_x64::Cache::fullyAssociative
+ };
+ 
+ static x86_x64::Cache L2Cache(u32 reg, x86_x64::Cache::Type type)
diff -pruN 0.0.23.1-4/debian/patches/python2.patch 0.0.23.1-5/debian/patches/python2.patch
--- 0.0.23.1-4/debian/patches/python2.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.0.23.1-5/debian/patches/python2.patch	2020-08-18 09:48:00.000000000 +0000
@@ -0,0 +1,14 @@
+Description: Update cxxtestgen shebang.
+Author: Dimitri John Ledkov <xnox@ubuntu.com>
+Bug-Debian: https://bugs.debian.org/967118
+Forwarded: not-needed
+Last-Update: 2020-08-18
+
+--- a/libraries/source/cxxtest-4.4/bin/cxxtestgen
++++ b/libraries/source/cxxtest-4.4/bin/cxxtestgen
+@@ -1,4 +1,4 @@
+-#! /usr/bin/env python
++#! /usr/bin/env python2
+ #
+ # The CxxTest driver script, which uses the cxxtest Python package.
+ #
diff -pruN 0.0.23.1-4/debian/patches/series 0.0.23.1-5/debian/patches/series
--- 0.0.23.1-4/debian/patches/series	2019-08-05 16:56:58.000000000 +0000
+++ 0.0.23.1-5/debian/patches/series	2020-08-18 09:48:00.000000000 +0000
@@ -1,2 +1,5 @@
 allow-build-with-root.patch
 fix-bindir.patch
+fix-ftbfs-gcc-10.patch
+python2.patch
+fix-ryzen-l3-cache-error.patch
diff -pruN 0.0.23.1-4/debian/rules 0.0.23.1-5/debian/rules
--- 0.0.23.1-4/debian/rules	2019-08-05 16:56:58.000000000 +0000
+++ 0.0.23.1-5/debian/rules	2020-08-18 09:48:00.000000000 +0000
@@ -60,4 +60,3 @@ override_dh_strip:
 
 override_dh_makeshlibs:
 	dh_makeshlibs -Xusr/lib/games/0ad
-
diff -pruN 0.0.23.1-4/debian/TODO 0.0.23.1-5/debian/TODO
--- 0.0.23.1-4/debian/TODO	2019-08-05 16:56:58.000000000 +0000
+++ 0.0.23.1-5/debian/TODO	1970-01-01 00:00:00.000000000 +0000
@@ -1,6 +0,0 @@
-Crash of Atlas editor on Wayland
-================================
-When https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=900678 is solved,
-document in debian/NEWS that Wayland users don't need the workaround anymore.
-
-Also, remove this note from this file :)
diff -pruN 0.0.23.1-4/debian/upstream/metadata 0.0.23.1-5/debian/upstream/metadata
--- 0.0.23.1-4/debian/upstream/metadata	1970-01-01 00:00:00.000000000 +0000
+++ 0.0.23.1-5/debian/upstream/metadata	2020-08-18 09:48:00.000000000 +0000
@@ -0,0 +1,7 @@
+Name: 0 A.D.
+Bug-Database: https://trac.wildfiregames.com/report
+Contact: https://play0ad.com/about/contact-us/
+Documentation: https://trac.wildfiregames.com/wiki
+FAQ: https://trac.wildfiregames.com/wiki
+Repository: https://svn.wildfiregames.com/public/ps/trunk/
+Repository-Browse: https://trac.wildfiregames.com/browser
